/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  SILT menu-processing module                                            *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define SILT
#define NOVARS
#define NOINIT

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "prog.h"
#include "max.h"
#include "silt.h"
#include "opusprm.h"
#include "dr.h"

extern struct m_pointers prm;
extern struct _menu menu;

extern int bytes_saved,
           protocol_num;

extern FILE *areasfile;

extern char last,
            do_prm,
            do_areas,
            do_menus,
            do_network,
            delete_sysbbs,
            do_sysbbs,
            do_sysdat,
            done_sys,
            done_equip,
            done_matrix,
            done_session,
            do_unattended;

extern struct _aidx *aidx;

extern char strings[],
            ctl_name[],
            line[],
            *ctl_delim,
            *unknown_ctl,
            *cantfind_file_ctl,
            *cc_section,
            *cc_area,
            *cc_menu,
            ver_14[],
            ver_16[];

extern int menuopt,
           offset,
           linenum,             /* Line number of BBS.CTL file! */
           priv_word,
           n_aidx,
           num_class;

static int alias_count=0;

int tsearch(char *key,struct _st base[],unsigned int num);

option IsOpt(char *token)
{
  int x;

  if ((x=tsearch(token,silt_table,silt_table_size)) != -1)
    return silt_table[x].opt;
  else return 0;
}

pascal Parse_Menu(FILE *ctlfile,char *name)
{
  FILE *menufile;

  char temp[MAX_LINE],  /* Contains entire line */
       temp2[MAX_LINE], /* First word on line */
       p[MAX_LINE],     /* First word on line */
       *sp;

  int x,
      y;

  option opt;

  linenum++;

  menuopt=0;

  Init_Menu();

  if (isnl(name))
  {
    printf("\n\aInvalid menu statement in line %d of CTL file!\n",linenum);
    exit(1);
  }

  if (!done_sys || !done_equip || !done_matrix || !done_session)
  {
    printf("\n\n\aError!  All menu statements must come AFTER the System, Equipment,\n");
    printf("Matrix, and Session sections!\n");
    exit(1);
  }

  while (fgets(line,MAX_LINE,ctlfile) != NULL)
  {
    Strip_Comment(line);

    if (!*line)
    {
      linenum++;
      continue;
    }

    priv_word=2;
    strcpy(temp,line);

    getword(line,p,ctl_delim,1);

TryAgain:

    if (isnl(p))
      ;
    else if (eqstri(p,"end"))
      break;
    else if (!do_menus)
      ;
    else if ((opt=IsOpt(p)) != 0)
      Parse_Option(opt,line);
    else if (eqstri(p,"menuheader"))
    {
      getword(line,p,ctl_delim,2);

      if (eqstri(p,"none"))
        menu.header=HEADER_none;
      else if (eqstri(p,"message"))
        menu.header=HEADER_message;
      else if (eqstri(p,"file"))
        menu.header=HEADER_file;
      else if (eqstri(p,"change"))
        menu.header=HEADER_change;
      else if (eqstri(p,"chat"))
        menu.header=HEADER_chat;
      else Unknown_Ctl(linenum,p);
    }
    else if (eqstri(p,"title"))
    {
      sp=fchar(line,ctl_delim,2);

      if ((menu.title=malloc(strlen(sp)+1))==NULL)
      {
        printf("\n\aNo memory for title `%s'!\n",sp);
        exit(1);
      }
      else strcpy(menu.title,sp);
    }
    else if (eqstri(p,"menufile"))
    {
      sp=fchar(line,ctl_delim,2);
      Add_Filename(sp);
      
      if ((menu.dspfile=malloc(strlen(sp)+1))==NULL)
      {
        printf("\n\aNo memory for MenuFile `%s'!\n",sp);
        exit(1);
      }
      else strcpy(menu.dspfile,sp);
    }
    else if (eqstri(p,"headerfile"))
    {
      sp=fchar(line,ctl_delim,2);
      Add_Filename(sp);
      
      if ((menu.headfile=malloc(strlen(sp)+1))==NULL)
      {
        printf("\n\aNo memory for MenuFile `%s'!\n",sp);
        exit(1);
      }
      else strcpy(menu.headfile,sp);
    }
    else if (eqstri(p,"menulength"))
    {
      getword(line,p,ctl_delim,2);
      menu.menu_length=atoi(p);
    }
    else if (eqstri(p,"menucolour"))
    {
      getword(line,p,ctl_delim,2);
      menu.hot_colour=atoi(p);
    }
    else if (eqstri(p,"app") || eqstri(p,"application"))
      ;
    else
    {
      static struct _flags
      {
        char *keyword;
        int flag_or_type;
        int value;
      }  flags[]={{"ctl"       , 1,  OFLAG_ctl               },
                  {"nodsp"     , 1,  OFLAG_nodsp             },
                  {"nocls"     , 1,  OFLAG_nocls             },
                  {"then"      , 1,  OFLAG_then | OFLAG_nodsp},
                  {"else"      , 1,  OFLAG_else | OFLAG_nodsp},
                  {"usrlocal"  , 1,  OFLAG_ulocal            },
                  {"usrremote" , 1,  OFLAG_uremote           },
                  {"else"      , 1,  OFLAG_else | OFLAG_nodsp},
                  {"reread"    , 1,  OFLAG_reread            },
                  {"local"     , 0,  AREATYPE_local          },
                  {"echo"      , 0,  AREATYPE_echo           },
                  {"matrix"    , 0,  AREATYPE_matrix         },
                  {NULL,0,0}};

      for (x=0;flags[x].keyword;x++)
      {
        if (eqstri(p,flags[x].keyword))
        {
          if (flags[x].flag_or_type==0)
          {
            /* If it was initialized */

            if (menu.options[menuopt]->areatype==AREATYPE_all)
              menu.options[menuopt]->areatype=0;

            menu.options[menuopt]->areatype |= flags[x].value;
          }
          else menu.options[menuopt]->flag |= flags[x].value;

          getword(line,p,ctl_delim,priv_word);
          priv_word++;
          goto TryAgain;
        }
      }

      /* If we got this far, it must have been invalid */

      Unknown_Ctl(linenum,p);
    }


    linenum++;
  }

  linenum++;

  if (do_menus)
  {
    for (y=1;;y++)
    {
      getword(name,temp,ctl_delim,y);

      if (! *temp)
        break;

      Add_Specific_Path(temp,temp2,strings+prm.menupath);

      strcat(temp2,".Mnu");

      if ((menufile=fopen(temp2,"wb"))==NULL)
      {
        printf("\n\aError opening `%s' for write!\n",temp2);
        exit(1);
      }

      fwrite((char *)&menu.header,sizeof(word),1,menufile);
      fwrite((char *)&menuopt,sizeof(word),1,menufile);

      fwrite((char *)&menu.menu_length,sizeof(word),1,menufile);
      fwrite((char *)&menu.hot_colour,sizeof(word),1,menufile);





      /* Now write the variable-length title string... */

      if (menu.title)
        x=strlen(menu.title);
      else x=0;

      fwrite((char *)&x,sizeof(int),1,menufile);

      if (x)
        fwrite(menu.title,x,1,menufile);





      /* And now the optional display file... */

      if (menu.dspfile)
        x=strlen(menu.dspfile);
      else x=0;

      fwrite((char *)&x,sizeof(int),1,menufile);

      if (x)
        fwrite(menu.dspfile,x,1,menufile);


      /* The header file */

      if (menu.headfile)
        x=strlen(menu.headfile);
      else x=0;

      fwrite((char *)&x,sizeof(int),1,menufile);

      if (x)
        fwrite(menu.headfile,x,1,menufile);

 
      /* Now write the individual menu options */

      for (x=0;x < menuopt;x++)
      {
        fwrite((char *)menu.options[x],sizeof(struct _opt),1,menufile);

        if (menu.options[x]->arglen)
          fwrite(menu.arg[x],menu.options[x]->arglen,1,menufile);

        if (menu.options[x]->kp_len)
          fwrite((char *)(unsigned long)menu.options[x]->keypoke,menu.options[x]->kp_len,1,menufile);
      }

      fclose(menufile);
    }
  }

  /* Free the remaining stuff */

  for (x=0;x < NUM_MENU;x++)
  {
    if (x < menuopt && menu.options[x]->kp_len)
      free((byte *)(unsigned long)menu.options[x]->keypoke);

    if (x < menuopt && menu.options[x]->arglen)
      free(menu.arg[x]);

    free(menu.options[x]);
  }

  if (menu.title)
    free(menu.title);

  if (menu.dspfile)
    free(menu.dspfile);

  if (menu.headfile)
    free(menu.headfile);

  if (do_menus)
    fclose(menufile);

  return 0;
}

/* I don't know why, but TC's bloody bsearch() function is broken!  It     *
 * wouldn't work for the `userlist' variable, and it appeared to be        *
 * skipping over it for some reason.  At any rate, this function           *
 * does approximately the same thing, except without the function          *
 * pointers and associated overhead.                                       */

int tsearch(char *key,struct _st base[],unsigned int num)
{
  int x,
      lastx=-1,
      lasthi,
      lastlo;

  char *s,*t;

  lasthi=num;
  lastlo=0;

  while (1)
  {
    x=((lasthi-lastlo) >> 1)+lastlo;

    if (lastx==x)
      return -1;

    lastx=x;

    for (s=key,t=base[x].token;tolower(*s)==tolower(*t);s++,t++)
      if (! *s)
        return (x);                       /* Found a match */

    if (tolower(*s) > tolower(*t))
      lastlo=x;
    else
      lasthi=x;
  }

  return -1;
}


Init_Menu()
{
  int x;

  memset(&menu,'\0',sizeof(struct _menu));

  menu.header=HEADER_none;
  menu.num_options=0;

  menu.menu_length=0;
  menu.hot_colour=-1;

  menu.title_len=0;
  menu.title=NULL;

  menu.dspfile_len=0;
  menu.dspfile=NULL;

  menu.headfile_len=0;
  menu.headfile=NULL;

  for (x=0;x < NUM_MENU;x++)
  {
    if ((menu.options[x]=(struct _opt *)malloc(sizeof(struct _opt)))==NULL)
    {
      printf("\n\aRan out of memory compiling menu!  Aborting...\n");
      exit(1);
    }

    menu.options[x]->type=nothing;
    menu.options[x]->arglen=0;
    menu.options[x]->flag=0;
    menu.options[x]->priv=HIDDEN;
    menu.options[x]->areatype=AREATYPE_all;
    menu.options[x]->flag=0;
    menu.options[x]->lock=0;
    menu.options[x]->kp_len=0;
    menu.arg[x]="";
  }

  return 0;
}






Parse_Option(option opt,char *line)
{
  static char temp[MAX_LINE],
              temp2[MAX_LINE],
              z1[MAX_LINE],
              z2[MAX_LINE],
              *p,
              *s;

  menu.options[menuopt]->type=opt;

  if (opt==display_menu || opt==display_file || opt==xtern_erlvl ||
      opt==xtern_run    || opt==xtern_dos    || opt==xtern_chain ||
      opt==xtern_concur || opt==area_change  || opt==key_poke    ||
      opt==o_if         || opt==o_menupath)
  {
    getword(line,temp,ctl_delim,priv_word);

    if (opt==display_file)
    {
      strcpy(temp2,temp);
      Add_Filename(temp2);
    }
    else strcpy(temp2,temp);

    if (menuopt >= NUM_MENU-1)
    {
      printf("\n\aToo many options in menu, line %d of control file!\n",
             linenum);
      exit(1);
    }

    if ((menu.arg[menuopt]=malloc(strlen(temp2)+1))==NULL)
    {
      printf("\n\aNo memory for option `%s'!\n",temp2);
      Compiling(-1,NULL,NULL);

      menu.options[menuopt]->type=nothing;
      return -1;
    }

    strcpy(menu.arg[menuopt],temp2);

    menu.options[menuopt]->arglen=strlen(menu.arg[menuopt]);

    priv_word++;
  }
  else menu.options[menuopt]->arglen=0;

  getword(line,temp,ctl_delim,priv_word++);

  menu.options[menuopt]->priv=Deduce_Priv(temp);
  menu.options[menuopt]->lock=(byte)Deduce_Lock(temp);

  s=p=fchar(line,ctl_delim,priv_word);

  getword(p,z1,"\"",1);
  getword(p,z2,"\"",3);

  memset(menu.options[menuopt]->name,'\0',sizeof(menu.options[menuopt]->name));

  strncpy(menu.options[menuopt]->name,z1,18);
  menu.options[menuopt]->name[18]='\0';


  if (*z2)
  {
    if ((menu.options[menuopt]->keypoke=(byte *)malloc(strlen(z2)+1))==NULL)
      menu.options[menuopt]->kp_len=0;
    else
    {
      menu.options[menuopt]->kp_len=(byte)strlen(z2);
      strcpy((char *)(unsigned long)menu.options[menuopt]->keypoke,z2);
    }
  }
  else menu.options[menuopt]->kp_len=0;

  memset(menu.options[menuopt++]->rsvd,'\0',sizeof(menu.options[menuopt]->rsvd));

  return 0;
}


void Strip_Comment(char *l)
{
  char *sp=l;
  int x;

  while (*sp)
  {
    if (isalpha(*sp))
      break;
    else if (ispunct(*sp))
    {
      *sp='\0';
      break;
    }

    sp++;
  }

  if (l[x=strlen(l)-1]=='\n')
    l[x]='\0';
}


void Attrib_Or(int clnum,int attr,struct _area *area)
{
  int x;

  if (clnum==-1)
  {
    for (x=0;x < MAXCLASS;x++)
      area->attrib[x] |= attr;
  }
  else area->attrib[clnum] |= attr;
}

void Attrib_And(int clnum,int attr,struct _area *area)
{
  int x;

  if (clnum==-1)
  {
    for (x=0;x < MAXCLASS;x++)
      area->attrib[x] &= attr;
  }
  else area->attrib[clnum] &= attr;
}


void pascal Add_Path(char *s,int warn)
{
  int x;

  char temp[MAX_LINE],
       temp2[MAX_LINE];

  if (!s)
    return;

   while (*s && (s[x=strlen(s)-1]==' ' || s[x]=='\t'))
    s[x]='\0';

  if (*s && s[x] != '\\')
  {
    s[++x]='\\';
    s[++x]='\0';
  }

  if (prm.sys_path)
  {
    if (! (s[1]==':' || *s=='\\' || *s=='/'))
    {
      strcpy(temp,strings+prm.sys_path);
      strcat(temp,s);
    }
    else strcpy(temp,s);

    if (temp[1] != ':')
    {
      temp2[0]=*(strings+prm.sys_path);
      temp2[1]=':';
      temp2[2]='\0';
      strcat(temp2,temp);
      strcpy(temp,temp2);
    }
  }
  else strcpy(temp,s);

  if (warn && !direxist(temp))
  {
    printf("\nWarning!  Path `%s' does not exist!\n",fancy_str(temp));
    Compiling(-1,NULL,NULL);
  }

  strcpy(s,temp);
}


void pascal Add_Filename(char *s)
{
  int x;

  char temp[MAX_LINE],
       temp2[MAX_LINE];

  if (!s)
    return;

   while (*s && (s[x=strlen(s)-1]==' ' || s[x]=='\t'))
    s[x]='\0';

  if (prm.sys_path)
  {
    if (! (s[1]==':' || *s=='\\' || *s=='/'))
    {
      strcpy(temp,strings+prm.sys_path);
      strcat(temp,s);
    }
    else strcpy(temp,s);

    if (temp[1] != ':')
    {
      temp2[0]=*(strings+prm.sys_path);
      temp2[1]=':';
      temp2[2]='\0';
      strcat(temp2,temp);
      strcpy(temp,temp2);
    }
  }
  else strcpy(temp,s);

  strcpy(s,temp);
}


/* Front end to firstchar() routine -- If word isn't found, return a       *
 * pointer to a NUL.                                                       */

char *fchar(char *str,char *delim,int wordno)
{
  char *s;

  if ((s=firstchar(str,delim,wordno))==NULL)
    return str+strlen(str);
  else return s;
}


Blank_Sys(struct _sys *sys,int mode)
{
  if (mode==0)
  {
    sys->ls_caller=0;
    sys->quote_pos=0L;
  }

  sys->priv=HIDDEN;
  sys->attrib=0;
  sys->lock=0;

  memset(sys->msgpath,'\0',sizeof(sys->msgpath));
  memset(sys->uppath,'\0',sizeof(sys->uppath));
  memset(sys->filepath,'\0',sizeof(sys->filepath));
  memset(sys->bbspath,'\0',sizeof(sys->bbspath));
  memset(sys->hlppath,'\0',sizeof(sys->hlppath));

  strcpy(sys->bbspath,strings+prm.menupath);
  strcpy(sys->hlppath,strings+prm.sys_path);
  strcat(sys->hlppath,"Hlp\\");

  return 0;
}

void Blank_Area(struct _area *area)
{
  memset(area,'\0',sizeof(struct _area));

  area->id=AREA_id;
  area->struct_len=sizeof(struct _area);
  area->area_type=0x00;

  strcpy(area->origin,strings+prm.system_name);

  area->msgpriv=area->filepriv=HIDDEN;
  area->origin_aka=-1;
}

void strnncpy(char *to,char *from,int len)
{
  if (from)
  {
    strncpy(to,from,len);
    to[len]='\0';
  }
  else *to='\0';
}

void Fmt(void)
{
  printf("\nCommand-line format:\n\n"

         "  SILT <ctl_file> [[-x]...]\n\n");

  printf("Valid switches are:\n\n"

         "  -p     Generates the Maximus .PRM file, and Opus .PRM files (if requested).\n"
         "  -a     Generates the AREA.* data files.  (Implied for -s103 and -s110.)\n"
         "  -o     Sort AREA.IDX numbers in numerical order.\n"
         "  -m     Generates the *.MNU menu data files.\n");
  printf("  -s103  Generates the Opus 1.03 SYSTEMxx.BBS files, DIR.BBS and ORIGIN.*.\n"
         "  -s110  Generates the Opus 1.10 SYSTEMxx.DAT files and ORIGIN.*.\n"
         "  -x     Generates all of the above.\n"
         "  -u     Unattended mode -- tells SILT never to prompt for user input.\n\n");

  printf("If no switches are specified, then SILT defaults to generating everything\n"
         "except the SYSTEMxx.BBS and SYSTEMxx.DAT files.\n");

  exit(1);
}


byte MaxPrivToOpus(int maxpriv)
{
  switch(maxpriv)
  {
    case SYSOP:
      return _SYSOP;

    case ASSTSYSOP:
      return _ASSTSYSOP;

    case CLERK:
      return _CLERK;

    case EXTRA:
      return _EXTRA;

    case FAVORED:
      return _FAVORED;

    case PRIVIL:
      return _PRIVEL;

    case WORTHY:
      return _WORTHY;

    case NORMAL:
      return _NORMAL;

    case LIMITED:
      return _LIMITED;

    case DISGRACE:
      return _DISGRACE;

    case TWIT:
      return _TWIT;
  }

  return _HIDDEN;
}

int makedir(char *d)
{
  char temp[PATHLEN];
  int x,y;

  for (*temp='\0';;)
  {
    if (!do_unattended)
    {
      printf("\rCreate dir `%s' [Y,n]? ",d);

      fgets(temp,PATHLEN,stdin);

      if (*temp && temp[strlen(temp)-1]=='\n')
        temp[strlen(temp)-1]='\0';

      *temp=toupper(*temp);

      Compiling(-1,NULL,NULL);
    }

    if (do_unattended || *temp=='Y' || *temp=='\n' || *temp=='\0')
    {
      x=make_dir(d);

      if (do_network)
      {
        strcpy(temp,d);

        if (temp[y=strlen(temp)-1] != '\\')
          strcat(temp,"\\");

        strcat(temp,"$EMPTY$.DIR");

        if ((y=open(temp,O_WRONLY | O_BINARY | O_CREAT | O_TRUNC,S_IREAD | S_IWRITE)) != -1)
          close(y);
      }

      return x;
    }
    else if (*temp=='N')
      return 0;
  }

  return 0;
}


Deduce_Priv(char *p)
{
  if (strnicmp(p,"hidden",6)==0)
    return HIDDEN;
  else if (strnicmp(p,"sysop",5)==0)
    return SYSOP;
  else if (strnicmp(p,"asstsysop",9)==0)
    return ASSTSYSOP;
  else if (strnicmp(p,"clerk",5)==0)
    return CLERK;
  else if (strnicmp(p,"extra",5)==0)
    return EXTRA;
  else if (strnicmp(p,"favored",5)==0)
    return FAVORED;
  else if (strnicmp(p,"privel",6)==0 || strnicmp(p,"privil",6)==0)
    return PRIVIL;
  else if (strnicmp(p,"worthy",6)==0)
    return WORTHY;
  else if (strnicmp(p,"normal",6)==0)
    return NORMAL;
  else if (strnicmp(p,"limited",7)==0)
    return LIMITED;
  else if (strnicmp(p,"disgrace",8)==0)
    return DISGRACE;
  else if (strnicmp(p,"twit",4)==0)
    return TWIT;
  else
  {
    printf("\a\nInvalid priv level `%s' on line %d of CTL file!\n",p,linenum);
    exit(1);
  }

  return 0;
}



Deduce_Attribute(char *a)
{
  if (eqstri(a,"private"))
    return 0;
  else if (eqstri(a,"crash"))
    return 1;
  else if (eqstri(a,"fileattach"))
    return 4;
  else if (eqstri(a,"killsent"))
    return 7;
  else if (eqstri(a,"hold"))
    return 9;
  else if (eqstri(a,"filerequest"))
    return 11;
  else if (eqstri(a,"updaterequest"))
    return 15;
  else if (eqstri(a,"fromfile"))
    return -22;
  else
  {
    printf("\a\nInvalid attribute `%s' on line %d of CTL file!\n",a,linenum);
    exit(1);
  }

  return 0;
}



Deduce_Class(int priv)
{
  int x;

  for (x=0;x < num_class;x++)
    if (prm.class[x].priv==priv)
      break;

  prm.class[x].priv=priv;

  if (x >= num_class)
    num_class++;

  return x;
}


Unknown_Ctl(int linenum,char *p)
{
  printf("\n\aUnknown statement in line %d of `%s':  `%s'?\n",linenum,
         ctl_name,p);
  Compiling(-1,NULL,NULL);

  return 0;
}


Compiling(char type,char *string,char *name)
{
  static char last_string[80],
              last_name[80];

  static int last_length=0;
  int x;

  if (type==-1)
    printf(last_string,last_name);
  else
  {
    if (last != type)   /* A NEW section */
    {
      putchar('\n');
      printf(string,name);
    }
    else
    {
      for (x=0;x < last_length;x++)
        printf("\x08 \x08");

      printf("%s",name);
    }

    last=type;
    last_length=strlen(name);
    strcpy(last_string,string);
    strcpy(last_name,name);
  }

  return 0;
}



Add_Backslash(char *s)
{
  int x;

  if (*s && s[x=strlen(s)-1] != '\\')
  {
    s[++x]='\\';
    s[++x]='\0';
  }

  return 0;
}



Remove_Backslash(char *s)
{
  int x;

  if (*s && s[x=strlen(s)-1]=='\\' && x != 2)
    s[x]='\0';

  return 0;
}




void pascal Parse_NetNode(char *netnode,int *zone,int *net,int *node,int *point)
{
  char *p;

  p=netnode;

  /* If we have a zone... */

  if (strchr(netnode,':'))
  {
    *zone=atoi(p);
    p=fchar(p,":",2);
  }

  /* If we have a net number... */

  if (strchr(netnode,'/'))
  {
    *net=atoi(p);
    p=fchar(p,"/",2);
  }

  /* We *always* need a node number... */

  *node=atoi(p);

  /* And finally check for a point number... */

  if (strchr(netnode,'.'))
    *point=atoi(fchar(p,".",2));
}


int Aidx_Cmp(struct _aidx *a1,struct _aidx *a2)
{
  if (a1->area < a2->area)
    return -1;
  else if (a1->area==a2->area)
    return 0;
  else return 1;
}


int Parse_Weekday(char *s)
{
  int x;

  for (x=0;x < 7;x++)
    if (eqstri(s,weekday[x]))
      return x;

  if (eqstri(s,"all"))
    return 7;

  printf("\n\aInvalid day-of-week `%s' on line %d of CTL file!\n",s,linenum);
  exit(1);
  return -1;
}



byte Deduce_Lock(char *p)
{
  byte lock;

  lock=0;

  /* Look for the slash in the string... */
  p=strchr(p,'/');

  /* If there *was* a slash, there must be some locks here... */

  if (p)
  {
    while (*++p)
    {
      if (*p >= '0' && *p <= '9')
        lock |= 1 << (*p-'1');
      else
      {
        printf("Invalid lock `%c' on line %d of CTL file!\n",*p,linenum);
        exit(1);
      }
    }
  }

  return lock;
}



Initialize_Prm()
{
  int x;

  /* Set the whole thing to zero, so items we've forgotten to initialize,  *
   * and all of the offsets, will be equal to zero initially.              */

  memset(&prm,'\0',sizeof(struct m_pointers));

  prm.id='M';
  prm.version=CTL_VER;
  prm.heap_offset=sizeof(struct m_pointers);
  prm.log_mode=LOG_terse;
  prm.max_baud=1200;
  prm.multitasker=MULTITASKER_none;
  prm.nlver=6;

  prm.exit_val=5;
  prm.edit_exit=0;
  prm.echo_exit=0;
  prm.protoexit=9;

  prm.flags=FLAG_autodate;

  prm.carrier_mask=128;
  prm.handshake_mask=0;

  prm.logon_priv=DISGRACE;
  prm.logon_time=10;
  prm.noise_ok=TRUE;

  prm.ctla_priv=prm.seenby_priv=HIDDEN;
  prm.dlall_priv=EXTRA;

  prm.min_ulist=DISGRACE;
  prm.max_ulist=ASSTSYSOP;

  prm.mc_reply_priv=TWIT;
  prm.mc_kill_priv=TWIT;

  prm.pvt_priv=SYSOP;
  prm.ulbbs_priv=ASSTSYSOP;

  for (x=0;x < 16;x++)
  {
    prm.msg_ask[x]=HIDDEN;
    prm.msg_assume[x]=HIDDEN;
  }

  prm.unlisted_priv=SYSOP;
  prm.unlisted_cost=50;

  prm.msg_fromfile=HIDDEN;

  prm.high_msgarea=prm.high_filearea=Set_Area_Name("ZZ");
  prm.begin_msgarea=prm.begin_filearea=Set_Area_Name("1");

  *strings='\0';

  for (x=0;x < MAXCLASS;x++)
  {
    prm.class[x].priv=0;
    prm.class[x].max_time=60;
    prm.class[x].max_call=60;
    prm.class[x].max_dl=400;
    prm.class[x].ratio=0;
    prm.class[x].min_baud=300;
    prm.class[x].min_file_baud=300;
  }

  return 0;
}



Parse_Ctlfile(char *ctlname)
{
  FILE *ctlfile;

  char p[MAX_LINE],     /* First word on line */
       *bufr;

  int x;

  linenum=1;

  strcpy(ctl_name,fancy_str(ctlname));

  printf("\nParsing `%s':",ctl_name);

  if ((ctlfile=fopen(ctlname,"r"))==NULL)
  {
    printf("  \aFatal error opening `%s' for read!\n",ctlname);
    exit(1);
  }

  if ((bufr=malloc(MAX_BUFR)) != NULL)
    setvbuf(ctlfile,bufr,_IOFBF,MAX_BUFR);

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        getword(line,p,ctl_delim,1);

        if (isnl(p))
          linenum++;
        else if (eqstri(p,"system"))
        {
          Compiling(LAST_section,cc_section,"System");
          Parse_System(ctlfile);
          done_sys=TRUE;
        }
        else if (eqstri(p,"equipment"))
        {
          Compiling(LAST_section,cc_section,"Equipment");
          Parse_Equipment(ctlfile);
          done_equip=TRUE;
        }
        else if (eqstri(p,"matrix"))
        {
          Compiling(LAST_section,cc_section,"Matrix");
          Parse_Matrix(ctlfile);
          done_matrix=TRUE;
        }
        else if (eqstri(p,"session"))
        {
          Compiling(LAST_section,cc_section,"Session");
          Parse_Session(ctlfile);
          done_session=TRUE;
        }
        else if (eqstri(p,"area"))
        {
          getword(line,p,ctl_delim,2);
          Compiling(LAST_area,cc_area,p);
          Parse_Area(ctlfile,p);
        }
        else if (eqstri(p,"menu"))
        {
          strcpy(p,fchar(line,ctl_delim,2));

          Compiling(LAST_menu,cc_menu,p);
          Parse_Menu(ctlfile,p);
        }
        else if (eqstri(p,"section"))
        {
          linenum++;

          while (fgets(line,MAX_LINE,ctlfile) != NULL)
          {
            linenum++;

            getword(line,p," \t\n",1);

            if (eqstri(p,"end"))
              break;
          }
        }
        else if (eqstri(p,"include"))
        {
          getword(line,p,ctl_delim,2);
          linenum++;

          x=linenum;
          last=LAST_none;

          Parse_Ctlfile(p);
          strcpy(ctl_name,ctlname);

          linenum=x;
        }
        else if (eqstri(p,"version14"))
          strcpy(ver_14,fchar(line,ctl_delim,2));
        else if (eqstri(p,"version17"))
          strcpy(ver_16,fchar(line,ctl_delim,2));
        else Unknown_Ctl(linenum++,p);
      }
      else linenum++;
    }
    else break;
  }

  fclose(ctlfile);

  if (bufr)
    free(bufr);

  return 0;
}



Parse_System(FILE *ctlfile)
{
  int x;

  char temp[MAX_LINE],  /* Contains entire line */
       p[MAX_LINE],     /* First word on line */
       *s2;

  linenum++;

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        strcpy(temp,line);

        getword(line,p,ctl_delim,1);

        if (isnl(p))
          ;
        else if (eqstri(p,"end"))     /* End system section */
          break;
        else if (eqstri(p,"name"))
        {
          s2=fchar(line,ctl_delim,2);

          if (strlen(s2) > 60)
            s2[61]='\0';

          Make_String(prm.system_name,s2);
        }
        else if (eqstri(p,"sysop"))
        {
          s2=fchar(line,ctl_delim,2);
          Make_String(prm.sysop,s2);
        }
        else if (eqstri(p,"snoop"))
          prm.flags |= FLAG_snoop;
        else if (eqstri(p,"video"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"fossil"))
            prm.video=VIDEO_fossil;
          else if (eqstri(p,"dos"))
            prm.video=VIDEO_dos;
          else if (eqstri(p,"fast"))
            prm.video=VIDEO_fast;
          else if (eqstri(p,"ibm"))
            prm.video=VIDEO_ibm;
          else if (eqstri(p,"ibm/snow"))
          {
            prm.video=VIDEO_ibm;
            prm.flags2 |= FLAG2_has_snow;
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"path"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"system"))
          {
            s2=fchar(line,ctl_delim,3);

            if (*s2=='\0' || s2[1] != ':' || s2[2] != '\\')
            {
              printf("\n\aError!  `Path System' on line %d must have a fully-qualified path!\n"
                     "ie.  Path System D:\\Path\\\n",linenum);
              exit(1);
            }

            Make_Path(prm.sys_path,s2);

            if (! direxist(strings+prm.sys_path))
              makedir(strings+prm.sys_path);

            if (! prm.net_info)
              prm.net_info=prm.sys_path;
          }
          else if (eqstri(p,"misc"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.misc_path,s2);

            if (! direxist(strings+prm.misc_path))
              makedir(strings+prm.misc_path);
          }
          else if (eqstri(p,"temp"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.temppath,s2);

            if (! direxist(strings+prm.temppath))
              makedir(strings+prm.temppath);

            sprintf(temp,"%s$TEMP$.$$$",strings+prm.temppath);

            /* Create an empty file in this directory, to make sure we     *
             * don't have the NetBIOS problem...                           */

            if ((x=open(temp,O_WRONLY | O_CREAT | O_TRUNC,S_IREAD | S_IWRITE)) != -1)
              close(x);
          }
          else if (eqstri(p,"outbound"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.junk,s2);
          }
          else if (eqstri(p,"ipc"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.ipc_path,s2);

            if (! direxist(strings+prm.ipc_path))
              makedir(strings+prm.ipc_path);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if ((x=1,eqstri(p,"uses")) || (x=2,eqstri(p,"file")))
        {
          getword(line,p,ctl_delim,2);
          s2=fchar(line,ctl_delim,3);

          Add_Filename(s2);

          if (eqstri(p,"password"))
            Make_Filename(prm.user_file,s2)
          else Unknown_Ctl(linenum,p);

          if (x==1 && do_prm)           /* USES statement */
            if (! fexist(s2))
            {
              *strrchr(s2,'.')='\0';
              printf(cantfind_file_ctl,s2,linenum);
              Compiling(-1,NULL,NULL);
            }
        }
        else if (eqstri(p,"log"))         /* Logging */
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"file"))
            Make_Filename(prm.log_name,fchar(line,ctl_delim,3))
          else if (eqstri(p,"mode"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"terse"))
              prm.log_mode=LOG_terse;
            else if (eqstri(p,"verbose"))
              prm.log_mode=LOG_verbose;
            else if (eqstri(p,"trace"))
              prm.log_mode=LOG_trace;
            else
            {
              Unknown_Ctl(linenum,p);
              prm.log_mode=LOG_terse;
            }
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"task"))         /* Task number */
          prm.task_num=(char)atoi(fchar(line,ctl_delim,2));
        else if (eqstri(p,"multitasker"))  /* Multitasker */
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"doubledos"))
            prm.multitasker=MULTITASKER_doubledos;
          else if (eqstri(p,"desqview"))
            prm.multitasker=MULTITASKER_desqview;
          else if (eqstri(p,"topview"))
            prm.multitasker=MULTITASKER_topview;
          else if (eqstri(p,"taskview"))
            prm.multitasker=MULTITASKER_taskview;
          else if (eqstri(p,"mswindows"))
            prm.multitasker=MULTITASKER_mswindows;
          else if (eqstri(p,"pc-mos"))
            prm.multitasker=MULTITASKER_pcmos;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"reboot"))  /* Watchdog */
          prm.flags |= FLAG_watchdog;
        else if (eqstri(p,"dos"))     /* DOS stuff */
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"close"))      /* Close all standard files */
            prm.flags |= FLAG_close_sf;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"no"))
          prm.flags2 |= FLAG2_noshare;
        else if (eqstri(p,"app") || eqstri(p,"application"))
          ;
        else Unknown_Ctl(linenum,p);
      }

      linenum++;
    }
    else break;
  }

  linenum++;

  return 0;
}


Parse_Equipment(FILE *ctlfile)
{

  char temp[MAX_LINE],  /* Contains entire line */
       p[MAX_LINE],     /* First word on line */
       *s2;


  linenum++;

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        strcpy(temp,line);

        getword(line,p,ctl_delim,1);

        if (isnl(p))
          ;
        else if (eqstri(p,"end"))
          break;
        else if (eqstri(p,"output"))
        {
          getword(line,p,ctl_delim,2);

          if (strnicmp(p,"com",3)==0)
          {
            if ((prm.com_port=atoi(p+3)-1)==-1 || prm.com_port > 15)
            {
              printf("\n\aInvalid COM port on line %d of CTL file!\n",linenum);
              Compiling(-1,NULL,NULL);
              prm.com_port=0;
            }
          }
          else if (eqstri(p,"local"))
            prm.flags |= FLAG_keyboard;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"baud"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"maximum"))
          {
            if ((prm.max_baud=atoi(fchar(line,ctl_delim,3)))==0)
            {
              prm.max_baud=1200;
              printf("\n\aInvalid baud rate on line %d of CTL file!\n",linenum);
              Compiling(-1,NULL,NULL);
            }
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"busy"))
        {
          s2=fchar(line,ctl_delim,2);
          Make_String(prm.m_busy,s2);
        }
        else if (eqstri(p,"mask"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"carrier"))
          {
            if ((prm.carrier_mask=atoi(fchar(line,ctl_delim,3)))==0)
            {
              printf("\aInvalid carrier mask on line %d of CTL file!\n",linenum);
              prm.carrier_mask=128;
            }
          }
          else if (eqstri(p,"handshaking"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"xon"))
              prm.handshake_mask |= FLOW_txoff;
            else if (eqstri(p,"cts"))
              prm.handshake_mask |= FLOW_cts;
            else if (eqstri(p,"dsr"))
              prm.handshake_mask |= FLOW_dsr;
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"send"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"break"))
            prm.flags |= FLAG_break_clr;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"app") || eqstri(p,"application"))
          ;
        else Unknown_Ctl(linenum,p);
      }

      linenum++;
    }
    else break;
  }

  linenum++;

  return 0;
}



Parse_Matrix(FILE *ctlfile)
{
  int x,y;

  char temp[MAX_LINE],  /* Contains entire line */
       temp2[MAX_LINE], /* Temporary holding tank */
       p[MAX_LINE],     /* First word on line */
       *s2;

  linenum++;

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        strcpy(temp,line);

        getword(line,p,ctl_delim,1);

        if (isnl(p))
          ;
        else if (eqstri(p,"end"))
          break;
        else if (eqstri(p,"address"))
        {
          if (alias_count==ALIAS_CNT)
          {
            printf("\n\aToo many network addresses on line %d of CTL file!\n",
                   linenum);
            Compiling(-1,NULL,NULL);
          }
          else
          {
            getword(line,p,ctl_delim,2);

            prm.address[alias_count].Zone=1;
            prm.address[alias_count].Net=-1;
            prm.address[alias_count].Node=-1;
            prm.address[alias_count].Point=0;

            Parse_NetNode(p,&prm.address[alias_count].Zone,
                          &prm.address[alias_count].Net,
                          &prm.address[alias_count].Node,
                          &prm.address[alias_count].Point);

            alias_count++;
          }
        }
        else if (eqstri(p,"gate"))
          prm.flags2 |= FLAG2_gate;
        else if (eqstri(p,"path"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"netinfo"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.net_info,s2);

            if (! direxist(strings+prm.net_info))
              makedir(strings+prm.net_info);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"nodelist"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"version"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"5"))
              prm.nlver=5;
            else if (eqstri(p,"6"))
              prm.nlver=6;
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"log"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"echomail"))
          {
            prm.flags |= FLAG_log_echo;

            getword(line,p,ctl_delim,3);

            if (isnl(p))
            {
              printf("\n\aError!  No EchoToss filename specified on line %d of control file!\n",linenum);
              exit(1);
            }

            Make_Filename(prm.echotoss_name,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"after"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"edit"))
          {
            getword(line,p,ctl_delim,4);
            prm.edit_exit=(char)atoi(p);
          }
          else if (eqstri(p,"echomail"))
          {
            getword(line,p,ctl_delim,4);
            prm.echo_exit=(char)atoi(p);
          }
          else if (eqstri(p,"local"))
          {
            getword(line,p,ctl_delim,4);
            prm.local_exit=(char)atoi(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"message"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"show"))
          {
            getword(line,p,ctl_delim,3);
            getword(line,temp2,ctl_delim,5);

            if (eqstri(p,"ctl_a"))
              prm.ctla_priv=Deduce_Priv(temp2);
            else if (eqstri(p,"seenby"))
              prm.seenby_priv=Deduce_Priv(temp2);
            else if (eqstri(p,"private"))
              prm.pvt_priv=Deduce_Priv(temp2);
            else Unknown_Ctl(linenum,p);
          }
          else if (eqstri(p,"send"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"unlisted"))
            {
              getword(line,p,ctl_delim,4);
              prm.unlisted_priv=Deduce_Priv(p);

              getword(line,p,ctl_delim,5);
              prm.unlisted_cost=atoi(p);
            }
            else Unknown_Ctl(linenum,p);
          }
          else if (eqstri(p,"edit"))
          {
            getword(line,p,ctl_delim,3);

            if ((x=1,eqstri(p,"ask")) || (x=2,eqstri(p,"assume")))
            {
              getword(line,p,ctl_delim,4);

              if (x==1)   /* ASK */
              {
                x=Deduce_Attribute(p);

                getword(line,p,ctl_delim,5);
                y=Deduce_Priv(p);

                if (x==-22)      /* fromfile */
                  prm.msg_fromfile=y;
                else prm.msg_ask[x]=y;
              }
              else        /* ASSUME */
              {
                x=Deduce_Attribute(p);

                getword(line,p,ctl_delim,5);
                y=Deduce_Priv(p);

                if (x==-22)     /* fromfile */
                  prm.msg_fromfile=y;
                else prm.msg_assume[x]=y;
              }
            }
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"app") || eqstri(p,"application"))
          ;
        else Unknown_Ctl(linenum,p);
      }

      linenum++;
    }
    else break;
  }

  linenum++;

  return 0;
}





void pascal Add_Specific_Path(char *frompath,char *topath,char *add_path)
{
  if (!prm.menupath || strchr(frompath,':') || strchr(frompath,'\\') ||
      strchr(frompath,'/'))

  {
    strcpy(topath,frompath);
    return;
  }

  strcpy(topath,add_path);
  strcat(topath,frompath);
}

int Make_Strng(char *value,int type)
{
  int x;

  char temp[MAX_LINE],
       *s;

  if (value==NULL)
    s="";
  else s=value;

  while (*s && (s[x=strlen(s)-1]==' ' || s[x]=='\t'))
    s[x]='\0';

  if (type)
  {
    if (!prm.sys_path)
    {
      printf("\n\aError in line %d of control file!  The `Path System' variable MUST be\nspecified before any other filenames or paths!\n",linenum);
      exit(1);
    }

    if (! (s[1]==':' || *s=='\\' || *s=='/'))
    {
      strcpy(temp,strings+prm.sys_path);
      strcat(temp,s);
    }
    else strcpy(temp,s);
  }
  else strcpy(temp,s);

  return (Add_To_Heap(temp,FALSE));
}



int Make_Pth(char *value)
{
  int x;

  char temp[MAX_LINE],
       *s;

  if (value==NULL)
    s="";
  else s=value;

   while (*s && (s[x=strlen(s)-1]==' ' || s[x]=='\t'))
    s[x]='\0';

  if (*s && s[x] != '\\')
  {
    s[++x]='\\';
    s[++x]='\0';
  }

  strcpy(temp,s);
  Add_Path(temp,1);

  return (Add_To_Heap(temp,TRUE));
}


int Add_To_Heap(char *s,int fancy)
{
  int old_ofs;
  char *o;

  /* If string is already in table, no need to add! */

  if ((o=memstr(strings,s,offset,strlen(s)+1)) != NULL)
  {
    old_ofs=o-strings;
    bytes_saved += strlen(s)+1;
  }
  else
  {
    strcpy(strings+offset,s);
    old_ofs=offset;
    offset += strlen(s)+1;

    if (fancy)
      fancy_str(strings+old_ofs);
  }

  if (offset >= HEAP_SIZE)
  {
    printf("\n\aRan out of memory while adding `%s' to .PRM heap.\n",s);
    exit(1);
  }

  return old_ofs;
}


